Remember
********

This manual is for Remember Mode, as distributed with Emacs 28.1.

   Copyright © 2001, 2004–2005, 2007–2022 Free Software Foundation, Inc.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.3 or any later version published by the Free Software
     Foundation; with no Invariant Sections, with the Front-Cover Texts
     being “A GNU Manual”, and with the Back-Cover Texts as in (a)
     below.  A copy of the license is included in the section entitled
     “GNU Free Documentation License”.

     (a) The FSF’s Back-Cover Text is: “You have the freedom to copy and
     modify this GNU manual.”

 — The Detailed Node Listing —

Backends

1 Preface
*********

This document describes remember.el, which was written by John Wiegley,
was once maintained by Sacha Chua, and is now maintained by the Emacs
developers.

   This document is a work in progress, and your contribution will be
greatly appreciated.

2 Introduction
**************

Todo lists, schedules, phone databases...  everything we use databases
for is really just a way to extend the power of our memory, to be able
to remember what our conscious mind may not currently have access to.

   There are many different databases out there—and good ones—which this
mode is not trying to replace.  Rather, it’s how that data gets there
that’s the question.  Most of the time, we just want to say “Remember
so-and-so’s phone number, or that I have to buy dinner for the cats
tonight.” That’s the FACT.  How it’s stored is really the computer’s
problem.  But at this point in time, it’s most definitely also the
user’s problem, and sometimes so laboriously so that people just let
data slip, rather than expend the effort to record it.

   “Remember” is a mode for remembering data.  It uses whatever back-end
is appropriate to record and correlate the data, but its main intention
is to allow you to express as _little_ structure as possible up front.
If you later want to express more powerful relationships between your
data, or state assumptions that were at first too implicit to be
recognized, you can “study” the data later and rearrange it.  But the
initial “just remember this” impulse should be as close to simply
throwing the data at Emacs as possible.

   Have you ever noticed that having a laptop to write on doesn’t
_actually_ increase the amount of quality material that you turn out, in
the long run?  Perhaps it’s because the time we save electronically in
one way, we’re losing electronically in another; the tool should never
dominate one’s focus.  As the mystic Farīd ud-Dīn ʿAṭṭār wrote: “Be
occupied as little as possible with things of the outer world but much
with things of the inner world; then right action will overcome
inaction.”

   If Emacs could become a more intelligent data store, where
brainstorming would focus on the _ideas_ involved—rather than the
structuring and format of those ideas, or having to stop your current
flow of work in order to record them—it would map much more closely to
how the mind (well, at least mine) works, and hence would eliminate that
very manual-ness which computers from the very beginning have been
championed as being able to reduce.

3 Implementation
****************

Hyperbole, as a data presentation tool, always struck me as being very
powerful, but it seemed to require a lot of “front-end” work before that
data was really available.  The problem with BBDB, or keeping up a
Bibl-mode file, is that you have to use different functions to record
the data, and it always takes time to stop what you’re doing, format the
data in the manner expected by that particular data interface, and then
resume your work.

   With “remember”, you just hit ‘M-x remember’ (you’d probably want to
bind this to an easily accessible keystroke, like ‘C-x M-r’), slam in
your text however you like, and then hit ‘C-c C-c’.  It will file the
data away for later retrieval, and possibly indexing.

   Indexing is to data what “studying” is in the real world.  What you
do when you study (or lucubrate, for some of us) is to realize certain
relationships implicit in the data, so that you can make use of those
relationships.  Expressing that a certain quote you remembered was a
literary quote, and that you want the ability to pull up all quotes of a
literary nature, is what studying does.  This is a more labor intensive
task than the original remembering of the data, and it’s typical in real
life to set aside a special period of time for doing this work.

   “Remember” works in the same way.  When you enter data, either by
typing it into a buffer, or using the contents of the selected region,
it will store that data—unindexed, uninterpreted—in a data pool.  It
will also try to remember as much context information as possible (any
text properties that were set, where you copied it from, when, how,
etc.).  Later, you can walk through your accumulated set of data (both
organized, and unorganized) and easily begin moving things around, and
making annotations that will express the full meaning of that data, as
far as you know it.

   Obviously this latter stage is more user-interface intensive, and it
would be nice if “remember” could do it as elegantly as possible, rather
than requiring a billion keystrokes to reorganize your hierarchy.  Well,
as the future arrives, hopefully experience and user feedback will help
to make this as intuitive a tool as possible.

4 Quick Start
*************

   • Type ‘M-x remember’.  The ‘*Remember*’ buffer should be displayed.

   • Type in what you want to remember.  The first line will be treated
     as the headline, and the rest of the buffer will contain the body
     of the note.

   • Type ‘C-c C-c’ (‘remember-finalize’) to save the note and close the
     ‘*Remember*’ buffer.

   By default, ‘remember-finalize’ saves the note in ‘~/emacs.d/notes’.
You can edit it now to see the remembered and timestamped note.  You can
edit this file however you want.  New entries will always be added to
the end.

   To remember a region of text, use the universal prefix.  ‘C-u M-x
remember’ displays a ‘*Remember*’ buffer with the region as the initial
contents.

   As a simple beginning, you can start by using the Text File backend,
keeping your ‘~/.emacs.d/notes’ file in outline-mode format, with a
final entry called ‘* Raw data’.  Remembered data will be added to the
end of the file.  Every so often, you can move the data that gets
appended there into other files, or reorganize your document.

   You can also store remembered data in other backends.  See
Backends.

   Here is one way to map the remember functions in your init file
(see The Emacs Initialization File (emacs)) to very
accessible keystrokes facilities using the mode:

     (define-key global-map (kbd "<f9> r") 'remember)
     (define-key global-map (kbd "<f9> R") 'remember-region)

   By default, remember uses the first annotation returned by
‘remember-annotation-functions’.  To include all of the annotations, set
‘remember-run-all-annotation-functions-flag’ to a non-‘nil’ value.

 -- User Option: remember-run-all-annotation-functions-flag
     Non-‘nil’ means use all annotations returned by
     ‘remember-annotation-functions’.

   You can write custom functions that use a different set of
remember-annotation-functions.  For example:

     (defun my/remember-with-filename ()
      "Always use the filename."
      (interactive)
      (let ((remember-annotation-functions '(buffer-file-name)))
       (call-interactively 'remember)))

   The ‘remember-notes’ command creates a “notes” buffer that visits the
file specified by the option ‘remember-data-file’.  The option
‘remember-notes-buffer-name’ specifies the name of the buffer.  The
buffer uses ‘remember-notes-initial-major-mode’ and
‘remember-notes-mode’ minor mode.  Use ‘C-c C-c’ to save and bury the
buffer.  The command ‘save-some-buffers’ saves this buffer without
asking.  This function is a suitable setting for
‘initial-buffer-choice’.

5 Function Reference
********************

‘remember.el’ defines the following interactive functions:

 -- Function: remember &optional initial
     Remember an arbitrary piece of data.  With a prefix, it will use
     the region as INITIAL.

 -- Function: remember-other-frame &optional initial
     Like ‘remember’, but uses a new frame.

 -- Function: remember-region &optional beg end
     If called from within the remember buffer, BEG and END are ignored,
     and the entire buffer will be remembered.  If called from any other
     buffer, that region, plus any context information specific to that
     region, will be remembered.

 -- Function: remember-clipboard
     Remember the contents of the current clipboard.  This is most
     useful for remembering things from a web browser or other X Windows
     applications.

 -- Function: remember-finalize
     Remember the contents of the current buffer.

 -- Function: remember-destroy
     Destroy the current remember buffer.

 -- Function: remember-mode
     This enters the major mode (see Major Modes (emacs))
     for output from ‘remember’.  This buffer is used to collect data
     that you want remember.  Just hit ‘C-c C-c’ when you’re done
     entering, and it will go ahead and file the data for latter
     retrieval, and possible indexing.

 -- Function: remember-notes &optional switch-to
     This returns the notes buffer, creating it if needed, and switches
     to it if called interactively (or if SWITCH-TO is non-‘nil’).  The
     notes buffer visits ‘remember-data-file’, and is named
     ‘remember-notes-buffer-name’.  It uses
     ‘remember-notes-initial-major-mode’ and ‘remember-notes-mode’ minor
     mode.

 -- Function: remember-notes-mode &optional arg
     This is a minor mode for the notes buffer.  It sets
     ‘buffer-save-without-query’ so that ‘save-some-buffers’ will save
     the notes buffer without asking.  Use ‘C-c C-c’ to run the command
     ‘remember-notes-save-and-bury-buffer’.

 -- Function: remember-notes-save-and-bury-buffer
     Save (if it is modified) and bury the current buffer.

6 Keystroke Reference
*********************

‘remember.el’ defines the following keybindings by default:

‘C-c C-c’
‘C-x C-s’
     Remember the contents of the current buffer (‘remember-finalize’).

‘C-c C-k’
     Destroy the current ‘*Remember*’ buffer (‘remember-destroy’).

7 Backends
**********

You can save remembered notes to a variety of backends.

7.1 Saving to a Text File
=========================

Insinuation
-----------

     (setq remember-handler-functions '(remember-append-to-file))

Options
-------

 -- User Option: remember-data-file
     The file in which to store unprocessed data.

 -- User Option: remember-leader-text
     The text used to begin each remember item.

7.2 Saving to Separate Text Files
=================================

Insinuation
-----------

     (setq remember-handler-functions '(remember-store-in-files))

Options
-------

 -- User Option: remember-data-directory
     The directory in which to store remember data as files.

 -- User Option: remember-directory-file-name-format
     A format string to use for naming files in the remember directory.
     File names are formed by calling ‘format-time-string’ at the time
     of saving, using this format string.

7.3 Saving to a Diary file
==========================

Insinuation
-----------

     (add-to-list 'remember-handler-functions 'remember-diary-extract-entries)

Options
-------

 -- User Option: remember-diary-file
     File for extracted diary entries.  If this is ‘nil’, then
     ‘diary-file’ will be used instead.

7.4 Saving to a Mailbox
=======================

Insinuation
-----------

     (add-to-list 'remember-handler-functions 'remember-store-in-mailbox)

Options
-------

 -- User Option: remember-mailbox
     The file in which to store remember data as mail.

 -- User Option: remember-default-priority
     The default priority for remembered mail messages.

7.5 Saving to an Org Mode file
==============================

For instructions on how to integrate Remember with Org Mode, consult
Capture (org).

Appendix A GNU Free Documentation License
*****************************************

                     Version 1.3, 3 November 2008

     Copyright © 2000, 2001, 2002, 2007, 2008 Free Software Foundation, Inc.
     <https://fsf.org/>

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document “free” in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of “copyleft”, which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.  We
     recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it can
     be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     “Document”, below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as “you”.  You accept
     the license if you copy, modify or distribute the work in a way
     requiring permission under copyright law.

     A “Modified Version” of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A “Secondary Section” is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document’s overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The “Invariant Sections” are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in the
     notice that says that the Document is released under this License.
     If a section does not fit the above definition of Secondary then it
     is not allowed to be designated as Invariant.  The Document may
     contain zero Invariant Sections.  If the Document does not identify
     any Invariant Sections then there are none.

     The “Cover Texts” are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A “Transparent” copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images composed
     of pixels) generic paint programs or (for drawings) some widely
     available drawing editor, and that is suitable for input to text
     formatters or for automatic translation to a variety of formats
     suitable for input to text formatters.  A copy made in an otherwise
     Transparent file format whose markup, or absence of markup, has
     been arranged to thwart or discourage subsequent modification by
     readers is not Transparent.  An image format is not Transparent if
     used for any substantial amount of text.  A copy that is not
     “Transparent” is called “Opaque”.

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and standard-conforming
     simple HTML, PostScript or PDF designed for human modification.
     Examples of transparent image formats include PNG, XCF and JPG.
     Opaque formats include proprietary formats that can be read and
     edited only by proprietary word processors, SGML or XML for which
     the DTD and/or processing tools are not generally available, and
     the machine-generated HTML, PostScript or PDF produced by some word
     processors for output purposes only.

     The “Title Page” means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, “Title
     Page” means the text near the most prominent appearance of the
     work’s title, preceding the beginning of the body of the text.

     The “publisher” means any person or entity that distributes copies
     of the Document to the public.

     A section “Entitled XYZ” means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     “Acknowledgements”, “Dedications”, “Endorsements”, or “History”.)
     To “Preserve the Title” of such a section when you modify the
     Document means that it remains a section “Entitled XYZ” according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow the
     conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document’s license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the title
     equally prominent and visible.  You may add other material on the
     covers in addition.  Copying with changes limited to the covers, as
     long as they preserve the title of the Document and satisfy these
     conditions, can be treated as verbatim copying in other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a machine-readable
     Transparent copy along with each Opaque copy, or state in or with
     each Opaque copy a computer-network location from which the general
     network-using public has access to download using public-standard
     network protocols a complete Transparent copy of the Document, free
     of added material.  If you use the latter option, you must take
     reasonably prudent steps, when you begin distribution of Opaque
     copies in quantity, to ensure that this Transparent copy will
     remain thus accessible at the stated location until at least one
     year after the last time you distribute an Opaque copy (directly or
     through your agents or retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of copies,
     to give them a chance to provide you with an updated version of the
     Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with the
     Modified Version filling the role of the Document, thus licensing
     distribution and modification of the Modified Version to whoever
     possesses a copy of it.  In addition, you must do these things in
     the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of previous
          versions (which should, if there were any, be listed in the
          History section of the Document).  You may use the same title
          as a previous version if the original publisher of that
          version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document’s
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled “History”, Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on the
          Title Page.  If there is no section Entitled “History” in the
          Document, create one stating the title, year, authors, and
          publisher of the Document as given on its Title Page, then add
          an item describing the Modified Version as stated in the
          previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in the
          “History” section.  You may omit a network location for a work
          that was published at least four years before the Document
          itself, or if the original publisher of the version it refers
          to gives permission.

       K. For any section Entitled “Acknowledgements” or “Dedications”,
          Preserve the Title of the section, and preserve in the section
          all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document, unaltered
          in their text and in their titles.  Section numbers or the
          equivalent are not considered part of the section titles.

       M. Delete any section Entitled “Endorsements”.  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          “Endorsements” or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option designate
     some or all of these sections as invariant.  To do this, add their
     titles to the list of Invariant Sections in the Modified Version’s
     license notice.  These titles must be distinct from any other
     section titles.

     You may add a section Entitled “Endorsements”, provided it contains
     nothing but endorsements of your Modified Version by various
     parties—for example, statements of peer review or that the text has
     been approved by an organization as the authoritative definition of
     a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end of
     the list of Cover Texts in the Modified Version.  Only one passage
     of Front-Cover Text and one of Back-Cover Text may be added by (or
     through arrangements made by) any one entity.  If the Document
     already includes a cover text for the same cover, previously added
     by you or by arrangement made by the same entity you are acting on
     behalf of, you may not add another; but you may replace the old
     one, on explicit permission from the previous publisher that added
     the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination all
     of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     “History” in the various original documents, forming one section
     Entitled “History”; likewise combine any sections Entitled
     “Acknowledgements”, and any sections Entitled “Dedications”.  You
     must delete all sections Entitled “Endorsements.”

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the documents
     in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow this
     License in all other respects regarding verbatim copying of that
     document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of a
     storage or distribution medium, is called an “aggregate” if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation’s users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document’s Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled “Acknowledgements”,
     “Dedications”, or “History”, the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided under this License.  Any attempt
     otherwise to copy, modify, sublicense, or distribute it is void,
     and will automatically terminate your rights under this License.

     However, if you cease all violation of this License, then your
     license from a particular copyright holder is reinstated (a)
     provisionally, unless and until the copyright holder explicitly and
     finally terminates your license, and (b) permanently, if the
     copyright holder fails to notify you of the violation by some
     reasonable means prior to 60 days after the cessation.

     Moreover, your license from a particular copyright holder is
     reinstated permanently if the copyright holder notifies you of the
     violation by some reasonable means, this is the first time you have
     received notice of violation of this License (for any work) from
     that copyright holder, and you cure the violation prior to 30 days
     after your receipt of the notice.

     Termination of your rights under this section does not terminate
     the licenses of parties who have received copies or rights from you
     under this License.  If your rights have been terminated and not
     permanently reinstated, receipt of a copy of some or all of the
     same material does not give you any rights to use it.

  10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     <https://www.gnu.org/licenses/>.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License “or any later version” applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If the
     Document does not specify a version number of this License, you may
     choose any version ever published (not as a draft) by the Free
     Software Foundation.  If the Document specifies that a proxy can
     decide which future versions of this License can be used, that
     proxy’s public statement of acceptance of a version permanently
     authorizes you to choose that version for the Document.

  11. RELICENSING

     “Massive Multiauthor Collaboration Site” (or “MMC Site”) means any
     World Wide Web server that publishes copyrightable works and also
     provides prominent facilities for anybody to edit those works.  A
     public wiki that anybody can edit is an example of such a server.
     A “Massive Multiauthor Collaboration” (or “MMC”) contained in the
     site means any set of copyrightable works thus published on the MMC
     site.

     “CC-BY-SA” means the Creative Commons Attribution-Share Alike 3.0
     license published by Creative Commons Corporation, a not-for-profit
     corporation with a principal place of business in San Francisco,
     California, as well as future copyleft versions of that license
     published by that same organization.

     “Incorporate” means to publish or republish a Document, in whole or
     in part, as part of another Document.

     An MMC is “eligible for relicensing” if it is licensed under this
     License, and if all works that were first published under this
     License somewhere other than this MMC, and subsequently
     incorporated in whole or in part into the MMC, (1) had no cover
     texts or invariant sections, and (2) were thus incorporated prior
     to November 1, 2008.

     The operator of an MMC Site may republish an MMC contained in the
     site under CC-BY-SA on the same site at any time before August 1,
     2009, provided the MMC is eligible for relicensing.

ADDENDUM: How to use this License for your documents
====================================================

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.3
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the “with...Texts.” line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of free
software license, such as the GNU General Public License, to permit
their use in free software.